
/* Copyright (C) 2004 whoosh777@blueyonder.co.uk  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file whoosh_LICENSE in this distribution.
  
  For more information about licensing, please email 
  whoosh777@blueyonder.co.uk
  For information on commercial licensing, email whoosh777@blueyonder.co.uk

  sometimes I may be away from the internet for several weeks, if I am 
  on the internet then I respond quickly to emails,

  My GS813 homepage http://www.whoosh777.pwp.blueyonder.co.uk
*/

/*
if you want your changes to this file to be maintained by whoosh777@blueyonder.co.uk,

ie as I develop further the viewers that the improvements should propagate 
through, 

then you must email me and I will send the current source + 
allocate you a time slot where my own development is "frozen" + 
I will give you rules to be followed in order for your changes to become 
incorporated.

the rules for this are much stricter than AFPL's rules,
this is because this is work in progress,

note also that such changes then become my private property to 
 use however I wish, you can also do whatever you wish with these changes 
ie they split into 2 copies one belongs to me, one belongs to you,

*/

/* PRODUCED CORRECT PRINTING! */
/*
#define 	SYNCHRONOUS 
*/
#define		PLANES		8
#define d( xyz )

/* #define d( xyz ) { PutStr( xyz ) ; PutStr(" " ) ; Flush( Output() ) ; } */

/* 10Mar2004 #include <iff_data.h> */
#include "turbo.h"

#include "protos.h"

/*
#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/asl.h>
*/

#include "whooshputnum.ch"


void turbo_graycm( turbo_data *td ) ;

static void *local_mess( void *user , char *mess )
{
PutStr( mess ) ; Flush( Output() ) ; 
}

/* prints number and returns stringsize of! */
static int user_num( turbo_data *td , int num )
{
int ret ;

ret = 0 ;
if( num < 0 )
	{
	td->user_mess( td->user , "-" ) ;
	ret = user_num( td , -num ) ;
	return( 1 + ret ) ;
	}
if( num >= 10 )
	{
	ret = user_num( td , num / 10 ) ;
	num = num - (10 * ( num / 10 )  ) ;
	}
	{
	char c[2] ;

	c[ 0 ] = '0' + num ;
	c[ 1 ] = 0 ;
	td->user_mess( td->user , c ) ;
	}
ret++ ;
return( ret ) ;
}

static void *local_calloc( void *user , int size , int num )
{
return( calloc( size , num ) ) ;
}

static void local_free( void *user , void *mem )
{
if( mem )free( mem ) ;
}

#undef calloc
#undef free

static int defaulter ;

static int defaults(void)
{
if( defaulter==0 )
	{
	char c[32]; 
	if( GetVar( "whooshdefaults" , c , 30 , 0 ) > 0 )
		{
		if( atoi( c ) )defaulter = 1 ;
		else defaulter = 2 ;
		}
	else defaulter = 2 ;
	}
if( defaulter==1 )return( 1 ) ;
else return( 0 ) ;
}

int env_hack ;

/* default is a keyword! */



double env_double( const char *name , double defaultval )
{
double ret ;
char c[32] ;

if( GetVar( name , c , 30 , 0 ) > 0 )
	{
	ret = atof( c ) ;
	if( env_hack==0 )
		{
		PutStr("env variable "); PutStr( name ) ; PutStr(" = ");
		myPutFloat( ret , 6 ) ;  PutStr("\n");
		/* 29 feb 2004 : */
		Flush( Output() ) ;
		}
	}
else
	{
	ret = defaultval ;
	if( defaults() && env_hack==0 )
		{
		PutStr("env variable "); PutStr( name ) ; PutStr(" = <");
		myPutFloat( ret , 6 ) ;  PutStr(">\n");
		/* 29 feb 2004 : */
		Flush( Output() ) ;
		}
	}
return( ret ) ;
}

unsigned difft_core( unsigned c )
{
return( (c & 0xff000000) ) ;  
}

static int difft( unsigned c , unsigned j )
{
if( difft_core( c ) != difft_core( j ) )return( 1 ) ;
else return( 0 ) ;
}

int  
colormap_verify(struct ColorMap *cm, int n, unsigned r, unsigned g , unsigned b)
	{
	int ret ;
	unsigned int i[3] ;

	ret = 1 ;
	
	GetRGB32( cm , n , 1 , i ) ;

		
	if( difft( r ,i[0]) )
		{
		PutStr("SetRGB32CM() error, r="); myPutHex( r ) ; 
		PutStr("=>"); myPutHex( i[0] ) ; PutStr("\n");
		Flush( Output() ) ;
		ret = 0 ;
		}
	if( difft( g , i[1]) )
		{
		PutStr("SetRGB32CM() error, g="); myPutHex( g ) ; 
		PutStr("=>"); myPutHex( i[1] ) ; PutStr("\n");
		Flush( Output() ) ;
		ret = 0 ;
		}
	if( difft( b , i[2] ) ) 
		{
		PutStr("SetRGB32CM() error, b="); myPutHex( b ) ; 
		PutStr("=>"); myPutHex( i[2] ) ; PutStr("\n");
		Flush( Output() ) ;
		ret = 0 ;
		}
	return( ret ) ;
	}

int aganormal ;

void whoosh_SetRGB32CM( struct ColorMap *cm , unsigned n , unsigned r ,
	unsigned g , unsigned b )
{
UWORD *hi , *lo ; unsigned R , G , B ;

/* dont trash memory!: */
if( cm==0 || n >= cm->Count )return ;

SetRGB32CM( cm , n , r , g , b ) ; /* otherwise it doesnt take effect! */


/*
PutStr("\nSetRGB32CM():{");
colormap_verify( cm , n , r , g , b ) ;
PutStr("}");
*/

/*
return ;
*/

hi = (UWORD *)cm->ColorTable ;
lo = (UWORD *)cm->LowColorBits ;

R = r >> 24 ; G = g >>24 ; B = b >> 24 ;

if( aganormal==0 )
	{
	hi[ n ] = ((R>>4)<<8) + ((G>>4)<<4) + (B>>4) ;
	lo[ n ] = ((R & 0xf)<<8) + ((G & 0xf)<<4) + (B & 0xf) ;
	}

if( 0 == colormap_verify( cm , n , r , g , b ) )
	{
	PutStr("\n\t:corrected SetRGB32CM() bug\n");
	}
}

void whoosh_SetRGB32( struct ViewPort *vp , unsigned n , unsigned r ,
	unsigned g , unsigned b )
{
UWORD *hi , *lo ; unsigned R , G , B ;

struct ColorMap *cm = vp->ColorMap ;

/* dont trash memory!: */

if( cm==0 || n >= cm->Count )return ;

SetRGB32( vp , n , r , g , b ) ; /* otherwise it doesnt take effect! */


/*
PutStr("\nSetRGB32CM():{");
colormap_verify( cm , n , r , g , b ) ;
PutStr("}");
*/

/*
return ;
*/

if( 0 )
  {
    hi = (UWORD *)cm->ColorTable ;
    lo = (UWORD *)cm->LowColorBits ;

    R = r >> 24 ; G = g >>24 ; B = b >> 24 ;

    if( aganormal==0 )
	{
	hi[ n ] = ((R>>4)<<8) + ((G>>4)<<4) + (B>>4) ;
	lo[ n ] = ((R & 0xf)<<8) + ((G & 0xf)<<4) + (B & 0xf) ;
	}
  }

if( 0 == colormap_verify( cm , n , r , g , b ) )
	{
	PutStr("\n\t:corrected SetRGB32CM() bug\n");
	}
}

/* BEWARE, this trick no good for multitasking code! */
static void print_SetRGB32CM( struct ColorMap *cm , unsigned n , unsigned r ,
	unsigned g , unsigned b )
{
int localaganormal ;

localaganormal = aganormal ;

aganormal = 0 ;

whoosh_SetRGB32CM( cm , n , r , g , b ) ;

aganormal = localaganormal ;
}

static int min( int x , int y )
{
if( x > y )return( y ) ;
else return( x ) ;
}


static void turbo_FreeBitMap( turbo_data *td , struct BitMap *bm )
{
int i ;

if( bm==0 )return; 

if( env_int("whooshbitmap",1))
	{
	FreeBitMap( bm ) ; 
	return;
	}


/* carefully done to deal with freeing failed turbo_AllocBitMap(): */
for( i = 0 ; i < bm->Depth ; i++ )
	{
	if( bm->Planes[ i ] ) 
		td->user_free( td->user , bm->Planes[ i ] ) ; 
	}

td->user_free( td->user , bm ) ;
}

static struct BitMap *turbo_AllocBitMap(turbo_data *td , int width , int height ,
		int depth ) 
{
struct BitMap *bm ;
int bytewidth , i ;

if( env_int("whooshbitmap",1))
	{
	bm = AllocBitMap( width , height , depth , BMF_CLEAR , 0 ) ;
	return( bm ) ;
	}

bm = td->user_calloc( td->user , 1 , sizeof( struct BitMap ) ) ;
if( bm==0 )goto cleanup ;

bytewidth = ((width + 15)/16) * 2 ;
bm->BytesPerRow = bytewidth ;
bm->Rows = height ;
bm->Depth = depth ;

for( i = 0 ; i < depth ; i++ )
	{
	bm->Planes[ i ] = td->user_calloc( td->user , bytewidth * height , 1 ) ;
	if( bm->Planes[ i ] == 0 )
		{
		turbo_FreeBitMap( td , bm ) ;
		bm = 0 ;
		goto cleanup ;
		}
	}

cleanup:

return( bm ) ;
}
 


void turbo_fill_io( turbo_data *td , int height , int special ) ;
void turbo_wait( turbo_data *td ) ;

/************** split functions below ****************/

turbo_data *turbo_alloc(const char *name, int pri, int width , int height , 
		int density ,
		int Height , void *user , USER_CALLOC user_calloc , 
			USER_FREE user_free , USER_MESS user_mess , int method )
{
turbo_data *td;

if( user_calloc==0 )user_calloc = local_calloc ;
if( user_free==0 )user_free = local_free ;
if( user_mess == 0 )user_mess = local_mess ;
/*
td = calloc( 1 , sizeof( turbo_data ) ) ;
*/

td = user_calloc( user , 1 , sizeof( turbo_data ) ) ;

/* capture function arguments */

td->user = user ; 
td->user_calloc = user_calloc ; 
td->user_free = user_free ; 
td->user_mess = user_mess ;
td->user_num = user_num ;

switch( method )
	{
	case TURBO_FULLCOLOUR: case TURBO_256G: case TURBO_1: break;
	default: 
	td->user_mess( td->user , "UNRECOGNIZED PRINTER METHOD,\n");
	goto cleanup;
	break;
	}

td->name = name ; td->pri = pri ; td->width = width ; 
td->height = height ; td->density = density ; 
td->Height = Height ;

/* he used v. 37 for both */
/* are the right libraries open? */
if( intuition()==0 )
	{
	td->user_mess( td->user , "intuition.library should be opened\n");
	goto cleanup;
	}

if( graphics()==0 )
	{
	td->user_mess( td->user , "graphics.library should be opened\n");
	goto cleanup;
	}

/* port, pio, device triple */
td->mp = CreateMsgPort() ;/* CreatePort( name , pri ) ; */
if( td->mp==0 )
	{ 
	td->user_mess( td->user , "couldnt create message port\n" );
	goto cleanup;
	}

td->pio = 
(union printerIO *)

/*
#if !defined(__PPC__)
CreateExtIO
#else
*/
CreateIORequest
/*
#endif
*/
( td->mp , sizeof( union printerIO ) );



if( td->pio==0 )
	{ 
	td->user_mess( td->user , "couldnt open pio\n" );
	goto cleanup;
	}

if ((OpenDevice( "printer.device" , 0 , &td->pio->ior , 0)))
	{
	td->user_mess( td->user , "couldnt open printer.device\n");
	goto cleanup;
	}

/* so we dont close a device that didnt open */
td->flags |= TURBO_CLOSEDEVICE ;

/* note whether we are on Turboprint */

/* 
QUESTION jun2003: FOR 1 bit turbo emulates AmigaOS 
this is the only change to the code for Turbo 1 bit,
other code though anticipates turbo 1 bit,
*/

if( turbo_is( td->pio , td ) /* && method!=TURBO_1*/ )
	td->flags |= TURBO_PRESENT ;

/* 
set up 2 RastPorts + BitMaps, render into one while other is printing 
for time efficiency 
will have small height and so be memory efficient
*/

td->planes = 8 ;

/* method==TURBO_1 => !TURBO_PRESENT allocation, except td->tp_ext */

if	(
	(method==TURBO_1) ||
	(td->flags & TURBO_PRESENT)==0 && 
	(method == TURBO_FULLCOLOUR || method == TURBO_256G || method == TURBO_1 ) 
	)
	{
	if( method==TURBO_FULLCOLOUR )
		{
		td->user_mess( td->user , "selecting AmigaOS 4096 method\n");
		td->flags |= TURBO_FULLCOLOUR ; 
		td->planes = 12 ;		
		}
	else if( method==TURBO_256G )
		{
		td->user_mess( td->user , "selecting AmigaOS 256 gray\n");
		td->flags |= TURBO_256G ; 
		td->planes = 8 ;
		}
	else if( method==TURBO_1 )
		{
		td->user_mess( td->user , "selecting 1 bit ");
		
		if( td->flags & TURBO_PRESENT )td->user_mess(td->user,"TP ");
		else td->user_mess(td->user,"AmigaOS ");
		
		td->user_mess( td->user, "b/w printing\n");
		td->flags |= TURBO_1 ; 
		td->planes = 1 ;
		}
	else
		{
		td->user_mess( td->user , "Not possible!!!, turbo.c\n");
		goto cleanup;
		}
	#ifndef __AROS__
	td->rp1 = td->user_calloc( td->user , 1 , sizeof( struct RastPort ) ) ;
	InitRastPort(td->rp1);
	#else
	td->rp1 = CreateRastPort() ;
	#endif
	/*
	td->bm1 = td->user_calloc( td->user , 1 , sizeof( struct BitMap ) ) ;
	*/


	td->bm1 = turbo_AllocBitMap( td , td->width , td->height , td->planes ) ; 

	/*
	AllocBitMap( td->width , td->height , td->planes , 
				BMF_CLEAR , 0 ) ;
	*/
	
	if( td->bm1==0 )
		{
		td->user_mess( td->user , "couldnt allocate first print bitmap\n");
		goto cleanup ;
		}
	
	td->rp1->BitMap = td->bm1;

	#ifndef __AROS__
	td->rp2 = td->user_calloc( td->user , 1 , sizeof( struct RastPort ) ) ;
	InitRastPort(td->rp2);
	#else 
	td->rp2 = CreateRastPort() ;
	#endif
	/*
	td->bm2 = td->user_calloc( td->user , 1 , sizeof( struct BitMap ) ) ;
	*/

	td->bm2 = turbo_AllocBitMap( td , td->width , td->height , td->planes ) ;


	/*
	AllocBitMap( td->width , td->height , td->planes , BMF_CLEAR , 
				0 ) ;
	*/
	if( td->bm2==0 )
		{
		td->user_mess( td->user, "couldnt allocate second print bitmap\n");
		goto cleanup ;
		}
	
	td->rp2->BitMap = td->bm2;
	}
else /* includes 216 method for !TURBO_PRESENT */
	{
	#ifndef __AROS__
	td->rp1 = td->user_calloc( td->user , 1 , sizeof( struct RastPort ) ) ;
	InitRastPort(td->rp1);
	#else
	td->rp1 = CreateRastPort() ;
	#endif
	td->bm1 = td->user_calloc( td->user , 1 , sizeof( struct BitMap ) ) ;
	td->rp1->BitMap = td->bm1;
	#ifndef __AROS__
	td->rp2 = td->user_calloc( td->user , 1 , sizeof( struct RastPort ) ) ;
	InitRastPort(td->rp2);
	#else
	td->rp2 = CreateRastPort() ;
	#endif
	td->bm2 = td->user_calloc( td->user , 1 , sizeof( struct BitMap ) ) ;
	td->rp2->BitMap = td->bm2;
	}

/* only part where TURBO_1 + TURBO_PRESENT behaves like TURBO */

if( td->flags & TURBO_PRESENT )
	td->tp_ext = td->user_calloc(td->user , 1 , sizeof( struct TPExtIODRP )) ;


/* allocate the bitplanes and TP vs AmigaOS conditional stuff */
if( (td->flags & TURBO_PRESENT) && method!=TURBO_1 )
	{
	if( method==TURBO_FULLCOLOUR )td->turbofactor = 3 ;
	else if( method==TURBO_256G )
		{
		td->turbofactor = 1 ;
		td->flags |= TURBO_256G ; 
		td->planes = 8 ; /* just for allocating color map purposes */
		turbo_graycm( td ) ;
		/* td->cm = GetColorMap( 1 << 8 ) ; */
		}
	/*
	else if( method==TURBO_1 )
		{
		td->flags |= TURBO_1 ; 
		td->planes = 1 ;
		}
	*/
	else 
		{
		td->user_mess( td->user , "internal error, in turbo_alloc()\n") ;
		goto cleanup;
		}

	InitBitMap( td->bm1 , 1 , td->width , td->height ) ;
	td->bm1->BytesPerRow = td->turbofactor * td->width;

	InitBitMap( td->bm2 , 1 , td->width , td->height ) ;
	td->bm2->BytesPerRow = td->turbofactor * td->width;

	td->yes = AllocMem( td->turbofactor * td->width * td->height ,
			MEMF_PUBLIC | MEMF_CLEAR);
	td->no  = AllocMem( td->turbofactor * td->width * td->height , 
			MEMF_PUBLIC | MEMF_CLEAR);
	
	if( td->yes==0 || td->no==0 )
		{
		td->user_mess( td->user , "couldn't allocate printer buffers\n") ;
		goto cleanup ;
		}
	
	td->bm1->Planes[ 0 ] = td->no ;
	td->bm2->Planes[ 0 ] = td->yes ;
	
	/*
	td->tp_ext = td->user_calloc(td->user , 1 , sizeof( struct TPExtIODRP )) ;
	*/
	}
else if( td->flags & TURBO_FULLCOLOUR ) /* AmigaOS 4096 */
	{
	td->cm = GetColorMap( 1 << td->planes ) ;
		{
		unsigned int R , G , B ;
		for( R = 0 ; R < 16 ; R++)
			{
			for( G=0 ; G< 16 ; G++)
				{
				for( B = 0 ; B < 16 ; B++ )
					{
					unsigned int i[3] , c ;
					c = 256 * R + 16 * G + B ; 
					print_SetRGB32CM( 
						td->cm , c , 
						R << 28 , 
						G << 28 , 
						B << 28 
						 ) ;
					GetRGB32( td->cm , c , 1 , &i ) ;
					if( R!=(i[0]>>28) || G!=(i[1]>>28) || 
						B!=(i[2]>>28) )
						td->user_mess( td->user , 
						"4096 SetRGB32CM error\n");
					}
				}
			}
		}
	}
else if( td->flags & TURBO_256G )
	{
	turbo_graycm( td ) ;
	}
else if( td->flags & TURBO_1 ) /* AmigaOS or TP */
	{
	td->cm = GetColorMap( 1 << td->planes ) ;
	print_SetRGB32CM(td->cm , 0 , 255 << 24, 255 << 24, 255 << 24);
	print_SetRGB32CM(td->cm , 1,  0 << 24, 0 << 24, 0 << 24);
	}
else if( 0 )	/* method==0 && ! TURBO_PRESENT */
	{
	int i ;
	
	InitBitMap( td->bm1 , td->planes , td->width , td->height ) ;
	InitBitMap( td->bm2 , td->planes , td->width , td->height ) ;
	
	for( i = 0 ; i< PLANES ; i++ )
		{
		td->bm1->Planes[ i ] = 
			AllocRaster( td->width , td->height ) ;
		td->bm2->Planes[ i ] = 
			AllocRaster( td->width , td->height ) ;
		if( td->bm1->Planes[ i ]==0 || td->bm2->Planes[ i ]==0 )
			{
			td->user_mess( td->user , "Couldnt allocate rasters\n");
			goto cleanup;
			}
		}
	
	td->cm = GetColorMap( 1 << PLANES ) ;
		{
		int R , G , B ;
		for( R = 0 ; R < 6 ; R++)
			{
			for( G=0 ; G<6 ; G++)
				{
				for( B = 0 ; B < 6 ; B++ ) 
					print_SetRGB32CM( td->cm , 36 * R + 6 * G + B , 
						(R * 51)<<24 , 
						(G * 51)<<24 , 
						(B * 51)<<24 
						 ) ;
				}
			}
		}
	}

/* if and else clauses are equally valid for TURBO_1 I think */
if( (td->flags & TURBO_PRESENT) && method!=TURBO_1 )
	{
	if( td->flags & TURBO_256G )
		{
		td->pio->iodrp.io_ColorMap = td->cm ;
		}
	}
else 	
	{
	td->pio->iodrp.io_ColorMap = td->cm ;
	/* pio->iodrp.io_Modes = HAM_KEY ; */
	
	/* 0 for cyber as this was how things were till recently */
	td->temp_rp = rp_alloc( td->rp1 , td->width , 0 ) ;
	if( td->temp_rp==0 )goto cleanup ;
	
	td->temp_array = array_alloc( td->width ) ;
	if( td->temp_array==0 )goto cleanup ;
	}

/* 22apr was , height , */
turbo_fill_io( td , td->height , 0 ) ;

/* assert success rather than failure */

td->flags |= TURBO_SUCCESS ;

cleanup:

if( td->flags & TURBO_SUCCESS );
else
	{
	turbo_free( td ) ;
	td = 0 ;
	}

if( td )
	{
	turbo_look( td ) ;
	/*
	turbo_print( td , td->height , 2 ) ;
	turbo_look( td ) ;
	turbo_print( td , td->Height , 2 ) ;
	turbo_look( td ) ;
	*/
	}

return( td ) ;
}

/* WARNING: rgb must not be accessed after this call!!! */
/* use double buffering, send rgb1, prepare rgb2, send rgb2, prepare rgb1 etc */
/* After the flush call also, we must wait!, usually rgb==0 */
void turbo_print(turbo_data *td , int height , int flush )
{
d( "t_p" ) ;

/* SUBTLE POINT: io must complete before modifying eg td->bm! */

/* so wait if necessary */
turbo_wait( td ) ;
d("1");
	{
	/* exchange the BitMap+RastPort pair */
	struct BitMap *bm1 , *bm2 ;
	struct RastPort *rp1 , *rp2 ;
	bm1 = td->bm1 ; bm2 = td->bm2 ;
	rp1 = td->rp1 ; rp2 = td->rp2 ;
	
	td->bm1 = bm2 ; td->bm2 = bm1 ;
	td->rp1 = rp2 ; td->rp2 = rp1 ;
	}

if( height > td->height && flush!=2 )
	{
	td->user_mess(td->user,
		"internal error: height too big in turbo_print()\n") ;
	return;
	}

/* re-fill the entire io request just to be safe */
if( flush==1 )turbo_fill_io( td , height , 0 ) ;
else if( flush==2 )turbo_fill_io( td , height , SPECIAL_NOPRINT ) ;
else turbo_fill_io( td , height , SPECIAL_NOFORMFEED ) ;
/* send new RastPort to printer.device */

d("2");

#ifdef SYNCHRONOUS

	DoIO( &td->pio->ior );

#else

	if( flush==1 || flush==2 )DoIO( &td->pio->ior ) ;
	else 
		{
		d("3");
		Forbid() ; Disable() ; 
		SendIO( &td->pio->ior ) ;
		td->flags |= TURBO_WAIT ;
		Enable() ; Permit() ;
		d("4");
		}

#endif
}

void turbo_wait( turbo_data *td )
{
d("t_w");
if( td->flags & TURBO_WAIT )
	{
	while( 1 )
		{
		struct Message *msg ;
		/* waits for a message rather than a signal */
		d("1");
		WaitPort( td->mp ) ;
		d("2");
		/* crashes printer.device with 8 000 000 3
		WaitIO( &td->pio->ior ) ;
		*/

		Forbid() ; Disable() ;
		msg = GetMsg( td->mp ) ;
		if( msg )td->flags &= ~(TURBO_WAIT) ;
		Enable() ; Permit() ;

		d("3");
		
		if( msg ) 
			{
			td->user_mess( td->user , "nonzero message ") ;
			td->user_num( td , (int)msg ) ;
			td->user_mess( td->user , "\n" );
			return ;
			}
		else td->user_mess( td->user , "zero message\n") ;
		continue ; 
		}
	}
}

/*********************************************/

struct IODRPReq *turbo_io( turbo_data *td )
{
return( &td->pio->iodrp ) ;
}

struct IODRPReq *pio_io( union printerIO *pio )
{
return( &pio->iodrp ) ;
}

/*********************************************/

struct PrinterData *turbo_pd( turbo_data *td )
{
return( (struct PrinterData *)( turbo_io( td )->io_Device ) ) ;
}

struct PrinterData *pio_pd( union printerIO *pio )
{
return( (struct PrinterData *)( pio_io( pio )->io_Device ) ) ;
}

/*********************************************/

struct PrinterExtendedData *turbo_ped( turbo_data *td )
{
return( &turbo_pd( td )->pd_SegmentData->ps_PED ) ;
}

struct PrinterExtendedData *pio_ped( union printerIO *pio )
{
return( &pio_pd( pio )->pd_SegmentData->ps_PED ) ;
}

/*********************************************/

struct Preferences *turbo_prefs( turbo_data *td )
{
return( &(turbo_pd( td )->pd_Preferences ) ) ;
}

struct Preferences *pio_prefs( union printerIO *pio )
{
return( &(pio_pd( pio )->pd_Preferences ) ) ;
}

/*********************************************/

turboprefs *turbo_turboprefs( turbo_data *td )
{
return( (turboprefs *)turbo_prefs( td ) ) ;
}

turboprefs *pio_turboprefs( union printerIO *pio )
{
return( (turboprefs *)pio_prefs( pio) ) ;
}

/*********************************************/


void turbo_look( turbo_data *td )
{
struct PrinterExtendedData *ped ;

ped = turbo_ped( td ) ;

PutStr("MaxXDots=="); myPutNum( ped->ped_MaxXDots ) ; PutStr("\n") ;
PutStr("MaxYDots=="); myPutNum( ped->ped_MaxYDots ) ; PutStr("\n") ;
PutStr("XDotsInch=="); myPutNum( ped->ped_XDotsInch ) ; PutStr("\n") ;
PutStr("YDotsInch=="); myPutNum( ped->ped_YDotsInch ) ; PutStr("\n") ;
PutStr("NumRows=="); myPutNum( ped->ped_NumRows ) ; PutStr("\n") ;
Flush( Output() ) ;
}

int turbo_width( turbo_data *td )
{
return( turbo_ped( td )->ped_MaxXDots ) ;
}

int turbo_height( turbo_data *td )
{
return( turbo_ped( td )->ped_MaxYDots ) ;
}

void turbo_fill_io( turbo_data *td , int height , int special )
{
/* reset everything each time just in case things got cleared */
d("t_i");
if( td->flags & TURBO_PRESENT )
	td->pio->iodrp.io_Command = PRD_TPEXTDUMPRPORT;
else	td->pio->iodrp.io_Command = PRD_DUMPRPORT;

td->pio->iodrp.io_RastPort = td->rp1 ; 
td->pio->iodrp.io_ColorMap = td->cm ;
td->pio->iodrp.io_SrcX = 0 ;
td->pio->iodrp.io_SrcY = 0 ;
td->pio->iodrp.io_SrcWidth = td->width ;
td->pio->iodrp.io_SrcHeight = height ;

	{
	struct Preferences *prefs ;
	prefs = turbo_prefs( td ) ;
	prefs->PrintAspect = ASPECT_HORIZ ;
	/* env_int("whooshaspect" , ASPECT_VERT )*/ ; 

	/* if this env variable missing we set the flag */
	
	if( env_int( "whooshalias" , 0 ) )prefs->PrintFlags |= ANTI_ALIAS ;
	if( env_int( "whooshfs" , 0 ) )prefs->PrintFlags |= FLOYD_DITHERING ;
	if( env_int( "whooshgs" , 0 ) )prefs->PrintFlags |= GREY_SCALE2 ;
	
	/* if( env_int( "whooshcentre", 0 ) ) */
	
	prefs->PrintFlags &= ~(CENTER_IMAGE) ;
	}

/* all Special Flags are possible, here we do not need any */
/* SPECIAL_NOFORMFEED for turbo_print() */
td->pio->iodrp.io_Special = special ;


{
td->pio->iodrp.io_DestRows = td->pio->iodrp.io_SrcHeight ;
td->pio->iodrp.io_DestCols = td->pio->iodrp.io_SrcWidth ;

goto EXPERIMENT ; 		/* EXPERIMENT */
}

if( td->fxdpi && env_int( "whooshmil" , 1 ) )
	{
	double fwidth ; int twidth ;
	
	/* dots / (dots/inch) == inch */

	twidth = turbo_width( td ) ;

	if( twidth && twidth < td->pio->iodrp.io_SrcWidth )
		td->pio->iodrp.io_SrcWidth = twidth ;
	else twidth = td->pio->iodrp.io_SrcWidth ;

	fwidth = 1000.0 * ((double)(twidth)/ td->fxdpi) ;
	
	/*
	if( twidth && env_int("whooshdouble" , 1 ) )
		{ 
		fwidth = fwidth * ((double)td->width)/((double)twidth) ;
		}
	*/
	
	fwidth = env_double( "whooshfactorw" , 1.0000 ) * fwidth ;

	td->pio->iodrp.io_Special |= SPECIAL_MILCOLS ; 
		/* 1/1000's of inch: */
		{
		int w ; double W ;
		w = (int)fwidth ; W = (double)w ;
		if( fwidth > W )
			{
			if( fwidth - W > 0.5 )
				td->pio->iodrp.io_DestCols = w + 1 ;
			else td->pio->iodrp.io_DestCols = w ;
			}
		else /* W >= fwidth */
			{
			if( W - fwidth > 0.5 )
				td->pio->iodrp.io_DestCols = w - 1 ;
			else td->pio->iodrp.io_DestCols = w ;
			}
		}
	}
else
	{
	int twidth ;
	
	twidth = turbo_width( td ) ;
	
	if( twidth && twidth < td->pio->iodrp.io_SrcWidth )
		td->pio->iodrp.io_SrcWidth = twidth ;
	else twidth = td->pio->iodrp.io_SrcWidth ;
	
	
	td->pio->iodrp.io_Special |= SPECIAL_FULLCOLS ; /* max poss width */
	td->pio->iodrp.io_DestCols = twidth ;
	}

if( td->fydpi && env_int( "whooshmil" , 1 ) )
	{
	double fheight ;
	
	/* dots / (dots/inch) == inch */
	
	fheight = 1000.0 * ((double)(height)/ td->fydpi) ;
	td->pio->iodrp.io_Special |= SPECIAL_MILROWS ; /* => 1/1000's of inch: */
	
	fheight = env_double( "whooshfactorh" , 1.0000 ) * fheight ;
	
	td->pio->iodrp.io_DestRows = (int)fheight ;
	}
else
	{
	td->pio->iodrp.io_DestRows = height ;
	}

EXPERIMENT: ; 

/* new: io.Modes must point to a new Structure (tp_ext) */
if( td->flags & TURBO_PRESENT )
	{
	td->pio->iodrp.io_Modes = (ULONG)(td->tp_ext);
	
	/* fill in the new structure */
	td->tp_ext->PixAspX = 1;	/* for the correct aspect ratio */
	td->tp_ext->PixAspY = 1;   /* normally the values of the monitor-structure */
			/* TicksX and TicksY */
	/* our bitmap is 3 bytes format RGB (24 bits) */
	if( td->flags & TURBO_256G )	td->tp_ext->Mode = TPFMT_Chunky8 ;

	else if( td->flags & TURBO_1 )	td->tp_ext->Mode = TPFMT_BitPlanes ;

	else td->tp_ext->Mode = TPFMT_RGB24;

		{
		/* 28th April: new */
		turboprefs *tprefs ;
		tprefs = turbo_turboprefs( td ) ;
		tprefs->GfxFF = 1 ;
		tprefs->Poster = 0 ;
		tprefs->Smoothing = 0 ;
		tprefs->p.PrintXOffset = 0 ;
		tprefs->LOffsRest = 0 ;
		tprefs->GfxTop = 0 ;
		tprefs->TOffsRest = 0 ;
		}
	}
else if( 0 ) /* removed this!: */
	{
	td->pio->iodrp.io_Special |= (td->density * SPECIAL_DENSITY1 ) ;
	td->pio->iodrp.io_Special |= SPECIAL_FULLCOLS ; /* max poss width */
	td->pio->iodrp.io_DestCols = td->width /* * td->density */ ;
			/* :width in printer pixels */
	td->pio->iodrp.io_DestRows = height ;
			/* :height in printer pixels */
	}
}

void turbo_free( turbo_data *td )
{
d("t_fr");
if( td==0 )return;

/* wait if necessary */
/* turbo_print( td , 1 , 2 ) ; */

turbo_wait( td ) ;
d("1");

if( td->pio )
	{
	/* only close the printer if it opened!!! */
	if( td->flags & TURBO_CLOSEDEVICE )
		{
			{
			/* whoosh expt: */
			/*
			td->pio->iodrp.io_Command = CMD_RESET ;
			DoIO( &td->pio->ior );
			*/
			d("2");
			}
		CloseDevice( &td->pio->ior );
		d("3");
		}

/*
#if !defined(__PPC__)
	DeleteExtIO
#else
*/
	  DeleteIORequest
/* #endif */

	  ( &td->pio->ior );
	d("4");
	td->pio = 0 ;
	}

if( td->mp ){ DeleteMsgPort( td->mp ) ; td->mp = 0 ; d("5");}
if( td->tp_ext ){ td->user_free( td->user , td->tp_ext ) ; td->tp_ext = 0 ; d("6");}

if( td->cm ){ FreeColorMap( td->cm ) ; td->cm = 0 ; d("7");}

/* different method of freeing bitplanes for AmigaOS td: FreeRaster vs FreeMem */
/* this is just for disconnected 216 AmigaOS colour I think */
if( (td->flags & TURBO_PRESENT)==0 
	&& (td->flags & (TURBO_1 | TURBO_256G | TURBO_FULLCOLOUR))==0 )
	{
	int i , width , height ;
	struct BitMap *bm1, *bm2 ;
	
	bm1 = td->bm1 ; bm2 = td->bm2 ;
	
	width = td->width ; height = td->height ;
	
	if( bm1 )
		{
		for( i = 0 ; i< td->planes ; i++ )
			{
			if( bm1->Planes[ i ] )
				{
				FreeRaster( bm1->Planes[ i ] , width , height) ;
				bm1->Planes[ i ] = 0 ; 
				d("8");
				}
			}
		}
	
	if( bm2 )
		{
		for( i = 0 ; i< td->planes ; i++ )
			{
			if( bm2->Planes[ i ] )
				{
				FreeRaster( bm2->Planes[ i ] , width , height ) ;
				bm2->Planes[ i ] = 0 ; 
				d("9");
				}
			}
		}
	}

/* different method of freeing bitplanes for AmigaOS td: FreeRaster vs FreeMem */
/* except for td->tp_ext TURBO_PRESENT + TURBO_1 allocates as for AmigaOS */
if	( 
	(td->flags & TURBO_1 ) ||
	(td->flags & TURBO_PRESENT)==0 && 
	(td->flags & (TURBO_FULLCOLOUR | TURBO_256G | TURBO_1)) 
	)
	{
	if( td->bm1 )turbo_FreeBitMap( td , td->bm1 ) ; 
	td->bm1 = 0 ; /* prevents refreeing below! */
	
	if( td->bm2 )turbo_FreeBitMap( td , td->bm2 ) ; 
	td->bm2 = 0 ;
	}

if( td->bm1 ){ td->user_free( td->user , td->bm1 ) ; td->bm1 = 0 ; }
if( td->rp1 )
	{ 
	#ifndef __AROS__
	td->user_free( td->user , td->rp1 ) ; 
	#else
	FreeRastPort( td->rp1 ) ;
	#endif
	td->rp1 = 0 ; 
	}
if( td->bm2 ){ td->user_free( td->user , td->bm2 ) ; td->bm2 = 0 ; }
if( td->rp2 )
	{ 
	#ifndef __AROS__
	td->user_free( td->user , td->rp2 ) ; 
	#else
	FreeRastPort( td->rp2 ) ;
	#endif
	td->rp2 = 0 ; 
	}

if( td->yes )
	{ 
	FreeMem( td->yes , td->width * td->height * td->turbofactor ) ; 
	td->yes = 0 ; 
	}

if( td->no )
	{ 
	FreeMem( td->no , td->width * td->height * td->turbofactor ) ; 
	td->no = 0 ; 
	}

if( td->temp_array )
	{
	array_free( td->temp_array , td->width ) ;
	td->temp_array = 0 ;
	}
if( td->temp_rp ){ rp_free( td->temp_rp ) ; td->temp_rp = 0 ;}
d("a");
td->user_free( td->user , td ) ; td = 0 ;
}

/*
before printing we need to know if TurboPrint is installed
therefore check the MatchWord in the "PrinterData" structure
element "pd_OldStack"
*/
/* use pio instead of td so that outside progs can use this */
int turbo_is( union printerIO *pio , turbo_data *td )
	{
	BOOL TP_Installed;
	struct PrinterData *PD;
	UWORD TPVersion;
	char* TPIdString;

	d("t_is");

	
	/*
	if( env_int( "whoosh216" , 0 ) )
		{
		PutStr("Env variable whoosh216 found, using 216 colour method\n");
		return( 0 ) ;
		}
	*/
	
	PD = (struct PrinterData *)pio->iodrp.io_Device;
	TP_Installed = ( ((ULONG *)(PD->pd_OldStk))[2] == TPMATCHWORD);

	TPVersion = pio->iodrp.io_Device->dd_Library.lib_Version;

	TPIdString = (char*)(pio->iodrp.io_Device->dd_Library.lib_IdString);

	if( TP_Installed==0 )
		{ 
		if( td )
			td->user_mess( td->user ,
				"TP not installed, will use AmigaOS printer\n"); 
		return( 0 ) ;
		}
	else if( TPVersion < 39 )
		{
		if( td )td->user_mess( td->user , "TurboPrint Pro 3 (or higher)" 
			" not installed, "
			"will use AmigaOS printer\n"
			);
		return( 0 ) ;
		}
	else 
		{
		/*
		you could now check chars 25-27 for version and revision
		e.g.: 
		*/
		
		/* whoosh: newly uncommented: */
		if( td )
			{
			td->user_mess( td->user , "Device-Version:" ) ;
			td->user_num( td , TPVersion ) ;
			td->user_mess( td->user , "\nTPIdString:" ) ;
			td->user_mess( td , &TPIdString[1] ) ;
			td->user_mess( td->user , "\n" ) ;
			}

		/* if (TP_Installed && TPVersion >= 39) */
		return( 1 ) ;
		}
	}


void turbo_graycm( turbo_data *td )
{
td->cm = GetColorMap( 1 << 8 ) ;
	{
	unsigned int i[ 3 ] ;
	int C ;
	for( C = 0 ; C < 256 ; C++)
		{
		print_SetRGB32CM(td->cm , C, C << 24, C << 24, C << 24);
		GetRGB32( td->cm , C , 1 , &i ) ;
		if( C!=(i[0]>>24) || C!=(i[1]>>24) || 
				C!=(i[2]>>24) )
			td->user_mess(td->user ,"256G SetRGB32CM error\n");
		}
	}
}


/* usually rows==1  */ /* rgb==gs8's loaned memory! */
void turbo_write_rgb_rows( turbo_data *td , unsigned char *rgb , int rows ,
			int quit )
{
int width , aheight , apos ; 

/* d("t_wr0"); */

apos = 0 ;

width = td->width ;

while( rows > 0 )
	{
	/* 
	td->done < td->height always! 
	td->Done < td->Height also
	verify about height > Height => flush early, ie always at Height?
	*/
	
	/*
	if( rows + td->done <= td->height )aheight = rows ;
	else 	*//* rows + td->done > td->height *//*
		aheight = td->height - td->done ;
	
	if( aheight + td->Done > td->Height )aheight = td->Height - td->Done ;
	*/

	aheight = min( td->height - td->done , td->Height - td->Done ) ;
	aheight = min( aheight , rows ) ;
	if( quit )aheight = 1 ; /* ! */
	
	if( (td->flags & TURBO_PRESENT) && 0==(td->flags & TURBO_1) )
		{
		/* keep this here because bm2 can change! */
		unsigned char *dest ;
		dest = td->bm2->Planes[ 0 ] ;
		if( 0 && env_int( "whooshturbodeb" , 0 ) )
			{
			int r ; unsigned int value ;

			/*
			td->user_mess( td->user , "t" ) ;
			*/
			
			r = td->done ;
			if	
				(
				r == (td->height - 1)
				/*
				env_int( "whooshrow0" , 0 )<=r && 
				r<=env_int( "whooshrow1" , 0 ) 
				*/
				)
				value = 0 ; /* black */
			else value = -1 ;	/* white */
				
				{
				int i , delta ;
				
				delta = td->turbofactor * width * td->done ;
				
			for( i = 0 ; i < td->turbofactor * width * aheight ; i++)
					dest[ delta + i ] = value ;
				}
			}
		else	/* normal method */
			{
			/*
			td->user_mess( td->user , "T" ) ;
			*/
			memcpy( 
			&dest[ td->turbofactor * width * td->done ] , 
			&rgb[ apos ] , 
			td->turbofactor * width * aheight ) ;
			}
		apos += ( td->turbofactor * width * aheight ) ;
		}
	else
		{
		int pos , row ; struct RastPort *rp2 ;
		
		/* this can change! */
		rp2 = td->rp2 ;
		
		if( td->flags & TURBO_FULLCOLOUR )
			{
			/* td->user_mess( td->user , "4" ) ; */
			for( row = 0 ; row < aheight ; row++ )
				{
				int mask , delta ;
				struct BitMap *bm ;
				unsigned char 
					**Planes ,
					*dest0 , *dest1 , *dest2 , *dest3 ,
					*dest4 , *dest5 , *dest6 , *dest7 ,
					*dest8 , *dest9 , *dest10 , *dest11 ;
				
				unsigned int r , g , b , 
				c0 , c1 , c2 , c3 , c4 , c5 , c6 , 
				c7 , c8 , c9 , c10 , c11 ;

				c0 = c1 = c2 = c3 = c4 = c5 = 0 ;
				c6 = c7 = c8 = c9 = c10 = c11 = 0 ;
				
				bm = rastport_bitmap( rp2 ) ;
				delta = (td->done + row) * bm->BytesPerRow ;
				Planes = bm->Planes ;
				
				dest0 = &Planes[ 0 ][ delta ] ;
				dest1 = &Planes[ 1 ][ delta ] ;
				dest2 = &Planes[ 2 ][ delta ] ;
				dest3 = &Planes[ 3 ][ delta ] ;
				dest4 = &Planes[ 4 ][ delta ] ;
				dest5 = &Planes[ 5 ][ delta ] ;
				dest6 = &Planes[ 6 ][ delta ] ;
				dest7 = &Planes[ 7 ][ delta ] ;
				dest8 = &Planes[ 8 ][ delta ] ;
				dest9 = &Planes[ 9 ][ delta ] ;
				dest10 = &Planes[ 10 ][ delta ] ;
				dest11 = &Planes[ 11 ][ delta ] ;
				
				pos = 0 ; mask = 1<<7 ;
				
				while( 1 )
					{
					r = rgb[ apos++ ] ; 
					g = rgb[ apos++ ] ; 
					b = rgb[ apos++ ] ; 

					if( b & 16)c0 |= mask ;
					if( b & 32)c1 |= mask ;
					if( b & 64)c2 |= mask ;
					if( b & 128 )c3 |= mask ;

					if( g & 16)c4 |= mask ;
					if( g & 32)c5 |= mask ;
					if( g & 64)c6 |= mask ;
					if( g & 128 )c7 |= mask ;

					if( r & 16)c8 |= mask ;
					if( r & 32)c9 |= mask ;
					if( r & 64)c10 |= mask ;
					if( r & 128 )c11 |= mask ;
					
					pos++ ;
					if( mask==1 || pos==width)
						{
						*(dest0++) = c0 ;
						*(dest1++) = c1 ;
						*(dest2++) = c2 ;
						*(dest3++) = c3 ;
						*(dest4++) = c4 ;
						*(dest5++) = c5 ;
						*(dest6++) = c6 ;
						*(dest7++) = c7 ;
						*(dest8++) = c8 ;
						*(dest9++) = c9 ;
						*(dest10++) = c10 ;
						*(dest11++) = c11 ;
						if( pos==width )break ;
						mask = (1<<7) ;
						c0 = c1 = c2 = c3 = c4 = c5 = 0 ;
						c6 = c7 = c8 = c9 = c10 = c11 = 0 ;
						}
					else
						{
						mask = (mask >> 1 ) ;
						}
					} /* while( 1 ) */
				} /* for row */
			}/* if 4096 */	
				/*		
				while( 1 )
					{
					unsigned int r , g , b , R , G , B , colno;
					
					if( pos==width )break ;
					pos++ ;
					
					r = rgb[ apos++ ] ; 
					g = rgb[ apos++ ] ; 
					b = rgb[ apos++ ] ; 
				
					R = r >> 4 ; 
					G = g >> 4 ; 
					B = b >> 4 ;
					
					colno = 256 * R + 16 * G + B ;
					
					{
					int depth ;
					for( depth = 0 ; depth < 12 ; depth++ )
						{
						char *dest ;
						dest = bm->Planes[ depth ] ;
						if( (1<<depth) & colno )
						  dest[ delta + bytepos ] |= mask ;
						else 
						dest[ delta + bytepos ] &= ~(mask);
						}
					}
					if( mask==1 )
						{
						mask = (1<<7) ;
						bytepos++ ;
						}
					else
						{
						mask = (mask >> 1 ) ;
						}
					}
				
				*/
		else if( td->flags & TURBO_256G )
			{
			/* td->user_mess( td->user , "g" ) ; */
			for( row = 0 ; row < aheight ; row++ )
				{
				WritePixelLine8
					( 
					rp2 , 
					0 ,	/* xstart */
					td->done + row ,	/* ystart */
					width ,	/* width */
					&rgb[ apos ] ,	/* not temp array!!!! */
					td->temp_rp 	/* temprp */
					) ;
				apos += width ;
				} /* for */
			}/* for */
		else if( td->flags & TURBO_1 )
			{
			/* td->user_mess( td->user , "1" ) ; */
			for( row = 0 ; row < aheight ; row++ )
				{
				int sbpr , dbpr ;
				struct BitMap *bm ; 
				unsigned char *dest ;
				bm = rastport_bitmap( rp2 ) ;
				dest = bm->Planes[ 0 ] ;
				sbpr = (width + 7)/8 ;
				dbpr = bm->BytesPerRow ;
				memcpy	(
					&dest[ dbpr * ( td->done + row ) ] ,
					&rgb[ apos ] ,
					sbpr 
					) ;
				apos += sbpr ;
				} /* for */
			}/* else if */
		else /* disconnected 216 colour AmigaOS */
			{
			for( row = 0 ; row < aheight ; row++ )
				{
				for( pos = 0 ; pos < width ; pos++ )
					{
					unsigned int r , g , b , R , G , B , colno;
				
					r = rgb[ apos++ ] ; 
					g = rgb[ apos++ ] ; 
					b = rgb[ apos++ ] ; 
				
					R = (2 * r + 51 )/102 ; 
					G = (2 * g + 51 )/102 ; 
					B = (2 * b + 51 )/102 ;
					colno = 36 * R + 6 * G + B ;
		
					SetAPen( rp2 , colno ) ;
					WritePixel( rp2 , pos , td->done + row ) ;
					} /* for */
				}/* for */
			}
		} /* else NOT TURBO_PRESENT */
	rows = rows - aheight ;
	td->done += aheight ;
	td->Done += aheight ;
	if( quit )
		{
		td->user_mess( td->user , 
			"quit signal: sending 1 line and flushing page\n" 
			) ;

		turbo_print( td , 1 , 1 ) ;
		td->done = 0 ; td->Done = 0 ; rows = 0 ;
		}
	if( td->Done==td->Height )
		{
		td->user_mess( td->user , "sending ");
		td->user_num( td , td->done ) ;
		td->user_mess( td->user , " line(s) and flushing page\n" );

		turbo_print( td , td->done , 1 ) ;
		td->done = 0 ; td->Done = 0 ;
		}
	/* now td->Done < td->Height again */
	else if( td->done==td->height )
		{
		td->user_mess( td->user , "sending " ); 
		td->user_num( td , td->done ) ;
		td->user_mess( td->user , " line(s)\n" ) ;

		turbo_print( td , td->done , 0 ) ;
		td->done = 0 ;
		}
	/* now td->done < td->height */
	}/* while 1 */
/* d("t_wr1"); */
}

